!=========================================================================
! Copyright (C) GemTalk Systems 1986-2013.  All Rights Reserved.
!
! $Id: obsrccollbkt.gs,v 1.7 2008-01-09 19:02:35 stever Exp $
!
! Superclass Hierarchy:
!   ObsoleteRcCollisionBucket, AbstractCollisionBucket, Array,
!   SequenceableCollection, Collection, Object.
!
!=========================================================================

! Create the class ObsoleteRcCollisionBucket, if it does not already exist

expectvalue %String
run
  AbstractCollisionBucket _newKernelSubclass: 'ObsoleteRcCollisionBucket'
    instVarNames: #()
    classVars: #()
    classInstVars: #()
    poolDictionaries: #[]
    inDictionary: Globals
    constraints: #[  ]
    instancesInvariant: false
    isModifiable: false
    reservedOop: 1369
%
expectvalue true
run
ObsoleteRcCollisionBucket classHistory at: 2 put: RcCollisionBucket .
^ ObsoleteRcCollisionBucket classHistory size == 2
%

removeallmethods ObsoleteRcCollisionBucket
removeallclassmethods ObsoleteRcCollisionBucket

category: 'For Documentation Installation only'
classmethod: ObsoleteRcCollisionBucket
installDocumentation

| doc txt |

doc := GsClassDocumentation _newForObsoleteGsClass: self asOfGsVersion: '5.0'.

txt := (GsDocText new) details:
'Existing instances should be migrated to RcCollisionBucket or otherwise
 processed as required, and then should be removed.' .
doc documentClassWith: txt.

self description: doc.
%

! ------------------- Class methods for ObsoleteRcCollisionBucket
! ------------------- Instance methods for ObsoleteRcCollisionBucket

category: 'Private'
method: ObsoleteRcCollisionBucket
_canonicalizeSymbolAt: offset oldSymbol: oldSym newSymbol: newSym

"Fixes the dictionary by replacing the entry.  If the symbol is one of the
 instance variables or is a value, updates it directly.  Otherwise, lets the
 KeyValueDictionary that references this collision bucket fix it."

| numInstVars index |

numInstVars := self _class instSize .
(offset <=  numInstVars) 
   ifTrue: [ self _unsafeAt: offset put: newSym ]
   ifFalse: [ " symbol is in the indexable part "

     index := offset - numInstVars .
     index even " symbol is a value "
       ifTrue: [ ^ self _unsafeAt: offset put: newSym ]
       ifFalse: [ " symbol is a key "
         self _halt:
           'Cannot canonicalize keys in an ObsoleteIdentityCollisionBucket'.
       ]
   ].
%

